SystemOrganization addCategory: #'Phantom-Core'!

ObjectAsMethodWrapper subclass: #PhAspectMethodWrapper
	instanceVariableNames: 'advice beforeAdvice aroundAdvice afterAdvice currentSelector currentArguments currentReceiver contextDictionary needCleanUp current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAspectMethodWrapper commentStamp: 'DanielGaldames 4/14/2011 01:09' prior: 0!
This class is used to wrap the methods declared on a ponicut!

!PhAspectMethodWrapper classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/18/2011 12:49'!
on: aClass selector: aSelector with: adviceCollection
	^(super on: aClass selector: aSelector)
		advice: adviceCollection;
		yourself.! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:49'!
advice
	^ advice ifNil: [advice := Set new.]! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:52'!
advice: aSet
	advice := aSet.
	self buildAdviceLists.! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:49'!
afterAdvice
	^ afterAdvice! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:50'!
afterAdvice: anAdviceCollection
	afterAdvice := anAdviceCollection.
	afterAdvice do: [:each | each type: #after]! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:47'!
aroundAdvice
	^ aroundAdvices! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:50'!
aroundAdvice: anAdviceCollection
	aroundAdvice := anAdviceCollection.
	aroundAdvice do: [:each | each type: #around]! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:51'!
beforeAdvice
	^ beforeAdvice! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:51'!
beforeAdvice: anAdviceCollection
	beforeAdvice := anAdviceCollection.
	beforeAdvice do: [:each | each type: #before]! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:57'!
buildAdviceGroupFor: aContext currentType: aType
	aContext currentAdviceGroup: aType.
	aContext adviceDictionary at: #before put: beforeAdvice.
	aContext adviceDictionary at: #after put: afterAdvice.
	aContext adviceDictionary at: #around put: aroundAdvice.
	aContext wrapper: self.! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:52'!
buildAdviceLists
	beforeAdvice := (advice select: [ :each | each type = #before ]) asArray.
	aroundAdvice := (advice select: [ :each | each type = #around ]) asArray.
	afterAdvice := (advice select: [ :each | each type = #after ]) asArray reversed! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:58'!
buildContextFor: anAdvice
	| aContext contextExp buildAdviceContext |
	contextExp := (anAdvice pointcut context) collect: [:each | (each = #proceed) ifTrue: [#method] ifFalse: [each]].
	buildAdviceContext := contextExp includes: #advice.
	aContext := PhContext new.
	(buildAdviceContext) ifTrue: [
		contextExp := contextExp select: [:each | (each = #advice) not].
		self buildAdviceGroupFor: aContext currentType: anAdvice type..].
	(contextExp) do: [:each |
		contextDictionary at: each
			ifPresent: [:cv | aContext perform: (each,#:) asSymbol with: (self perform: cv asSymbol)]
			ifAbsent: [self error: 'Invalid context definition']].
	(contextExp includes: #method) ifTrue: [
		aContext arguments: currentArguments.
		aContext receiver: currentReceiver.
		aContext selector: currentSelector].
	(anAdvice pointcut dynamicContext) ifNotNilDo: [:block |
		block value: aContext value: thisContext].  
	^ aContext! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/17/2011 16:45'!
current
	^ current! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/17/2011 16:45'!
current: anObject
	current := anObject! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 3/28/2011 13:13'!
currentArguments 
	^ currentArguments! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 3/28/2011 13:13'!
currentReceiver 
	^ currentReceiver! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 3/28/2011 13:13'!
currentSelector
	^ currentSelector! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 3/30/2011 10:14'!
currentSender
	"thisContext contextStack inspect."
	(1 to: (thisContext contextStack) size) reverseDo: [:idx |
		(((thisContext contextStack) at: idx) receiver == self) ifTrue: [
			^(thisContext contextStack at: (idx+1)) receiver]].
	self error: 'sender not found'
	"^(thisContext contextStack at: 14) receiver"! !

!PhAspectMethodWrapper methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/3/2011 13:55'!
initialize
	super initialize.
	needCleanUp := false.
	contextDictionary := Dictionary newFrom: {
		#arguments -> #currentArguments.
		#receiver -> #currentReceiver.
		#selector -> #currentSelector.
		#sender -> #currentSender.
		#method -> #oldMethod}! !

!PhAspectMethodWrapper methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/17/2011 01:04'!
install
	(self wrappedClass localSelectors includes: self selector) 
		ifTrue: [	needCleanUp := false.]
		ifFalse: [needCleanUp := true].
	super install.! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/10/2011 23:48'!
needCleanUp
	^ needCleanUp! !

!PhAspectMethodWrapper methodsFor: 'accessing' stamp: 'DanielGaldames 4/10/2011 23:48'!
needCleanUp: anObject
	needCleanUp := anObject! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:54'!
run: aSelector with: arguments in: aReceiver
	| aResult |
	currentSelector := aSelector.
	currentArguments := arguments.
	currentReceiver := aReceiver.
	self runBeforeAdvice.
	aResult := self runAroundAdvice.
	self runAfterAdvice.
	^aResult.! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:53'!
runAfterAdvice
	current := 1.
	[ current <= afterAdvice size ]
		whileTrue: [ 
			| currentAdvice |
			currentAdvice := afterAdvice at: current.
			currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
				ifTrue: [ currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
				ifFalse: [ currentAdvice run ].
			current := current + 1. ]! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:54'!
runAroundAdvice
	| aResult |
	current := 1.
	aroundAdvice notEmpty
		ifTrue: [ 
			[ current <= aroundAdvice size ]
				whileTrue: [ 
					| currentAdvice |
					currentAdvice := aroundAdvice at: current.
					currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
						ifTrue: [ aResult := currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
						ifFalse: [ aResult := currentAdvice run ].
					current := current + 1. ] ]
		ifFalse: [ aResult := oldMethod valueWithReceiver: currentReceiver arguments: currentArguments ].
	^ aResult! !

!PhAspectMethodWrapper methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 12:54'!
runBeforeAdvice
	current := 1.
	[ current <= beforeAdvice size ]
		whileTrue: [ 
			| currentAdvice |
			currentAdvice := beforeAdvice at: current.
			currentAdvice pointcut context notEmpty | currentAdvice pointcut dynamicContext notNil
				ifTrue: [ currentAdvice runWithin: (self buildContextFor: currentAdvice) ]
				ifFalse: [ currentAdvice run ].
			current := current + 1. ]! !

!PhAspectMethodWrapper methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/11/2011 01:00'!
uninstall
	self wrappedClass ifNil: [^self].
	super uninstall.
	needCleanUp ifTrue: [
		SystemChangeNotifier uniqueInstance doSilently: [self wrappedClass removeSelector: self selector]]! !

PPCompositeParser subclass: #PhPrecedenceRulesParser
	instanceVariableNames: 'letter word any identifier anysubclass identifierStar starIdentifierStar starAny'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPrecedenceRulesParser commentStamp: 'DanielGaldames 4/14/2011 01:54' prior: 0!
This class is responsable to parse the precedence rules defined on a pointcut or aspect.!

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:13'!
any
	^ $* asParser! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:13'!
anysubclass
	^$+ asParser! !

!PhPrecedenceRulesParser methodsFor: 'node set generation' stamp: 'DanielGaldames 3/25/2011 12:17'!
buildNodeSetFrom: aParserNode
	| aSet |
	aSet := Set new.
	((aParserNode at: 1) matches: (PhAspect name asString)) ifTrue: [aSet add: PhAspect].
	PhAspect allSubclasses do: [:asp |
		((aParserNode at: 1) matches: (asp name asString)) ifTrue: [aSet add: asp]].
	(aParserNode at: 2) notNil ifTrue: [
		| subs |
		subs := Set new.
		aSet do: [:asp | asp allSubclasses do: [:sub | subs add: sub]].
		subs do: [:asp | aSet add: asp.]].
	^aSet collect: [:asp | AspectNode new aspect: asp].! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:55'!
identifier
	^ (letter, word star) flatten! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/25/2011 11:56'!
identifierStar
	^ (identifier, any optional, anysubclass optional) ==> [:node |
		| precedenceParser|
		precedenceParser := (node at: 1) asParser.
		(node at: 2) notNil ifTrue: [precedenceParser := precedenceParser, #word asParser star].
		Array with: precedenceParser with: (node at: 3)]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:10'!
letter
	^ #letter asParser! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/29/2011 22:09'!
starAny
	^ (any) ==> [:node | Array with: (#word asParser star) with: nil]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/25/2011 12:21'!
starIdentifierStar
	^ (any, word plus flatten, any optional, anysubclass optional) ==> [:node |
		| precedeceParser |
		precedeceParser := (#word asParser starGreedy: ((node at: 2) asParser)), (node at: 2) asParser.
		(node at: 3) notNil ifTrue: [precedeceParser := precedeceParser, #word asParser star].
		Array with: precedeceParser with: (node at: 4)]! !

!PhPrecedenceRulesParser methodsFor: 'parser' stamp: 'DanielGaldames 3/25/2011 11:46'!
start
	^ (identifierStar / starIdentifierStar / starAny) end ==> [:node | self buildNodeSetFrom: node  ]! !

!PhPrecedenceRulesParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/24/2011 23:56'!
word
	^ #word asParser! !

PPCompositeParser subclass: #PhReceiverParser
	instanceVariableNames: 'starToken nameToken plusToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

PhReceiverParser class
	instanceVariableNames: 'classAndSubclassAction subclassesAction metaNameAction nameAction'!

!PhReceiverParser commentStamp: 'DanielGaldames 4/14/2011 01:55' prior: 0!
this class is responsable to parse the receivers declared on a pointcut.!

PhReceiverParser class
	instanceVariableNames: 'classAndSubclassAction subclassesAction metaNameAction nameAction'!

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/21/2011 14:51'!
generateReceiverClassParser: aParserNode
	| aNameParser classParser |
	aNameParser := ((aParserNode at: 2) at: 1) asParser.
	(aParserNode at: 1) notNil ifTrue: [aNameParser := (#word asParser starGreedy: aNameParser), aNameParser].
	((aParserNode at: 2) at: 2) notNil ifTrue: [aNameParser := aNameParser, #word asParser star].
	classParser := #word asParser plus, (#space asParser plus), 'subclass:' asParser, (#space asParser plus), $# asParser, aNameParser, (#blank asParser | #newline asParser).
	"subclassParser := aNameParser, #space asParser plus, 'subclass:' asParser."
	(aParserNode at: 3) notNil
		ifTrue: [ | matchedClasses subclassParser |
			matchedClasses := (SmalltalkImage current allClasses) select: [:each |
				classParser matches: each definition].
			matchedClasses do: [:each |
				each allSubclasses do: [:s | classParser := classParser / s definition asParser]].
			^classParser]
		ifFalse: [^classParser]
	! !

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/21/2011 14:47'!
generateReceiverMetaclassParser: aParserNode
	| aNameParser metaclassParser |
	aNameParser := ((aParserNode at: 2) at: 1) asParser.
	(aParserNode at: 1) notNil ifTrue: [aNameParser := (#word asParser starGreedy: aNameParser), aNameParser].
	((aParserNode at: 2) at: 2) notNil ifTrue: [aNameParser := aNameParser, #word asParser star].
	metaclassParser := aNameParser, #space asParser plus, 'class' asParser,(#blank asParser | #newline asParser).
	(aParserNode at: 3) notNil
		ifFalse: [^metaclassParser]
		ifTrue: [
			| matchedMetaclasses |
			matchedMetaclasses := (SmalltalkImage current allClasses) collect: [:each | each class] thenSelect: [:each |
				metaclassParser matches: each definition].
			matchedMetaclasses do: [:each |
				each allSubclasses do: [:s | metaclassParser := metaclassParser / s definition asParser]].
			^metaclassParser.]! !

!PhReceiverParser methodsFor: 'class parser generation' stamp: 'DanielGaldames 3/17/2011 21:02'!
generateReceiverParser: aParseNode
	^(((aParseNode at: 2) at: 3) notNil)
		ifTrue: [self generateReceiverMetaclassParser: aParseNode]
		ifFalse: [self generateReceiverClassParser: aParseNode]! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/16/2011 00:05'!
nameToken
	^((#letter asParser, #word asParser plus) flatten, starToken optional, ' class' asParser optional).! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/15/2011 23:14'!
plusToken
	^$+ asParser! !

!PhReceiverParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/15/2011 23:13'!
starToken
	^$* asParser! !

!PhReceiverParser methodsFor: 'parser' stamp: 'DanielGaldames 3/17/2011 20:38'!
start
	^((starToken optional, nameToken, plusToken optional) end) ==> [:node |
		self generateReceiverParser: node.]! !

PPCompositeParser subclass: #PhSelectorParser
	instanceVariableNames: 'identifier keyword unary binary multiword anyKeyUnary anyKeyMulti'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhSelectorParser commentStamp: 'DanielGaldames 4/14/2011 01:56' prior: 0!
this class is responsable to parse the selectors declared on a pointcut.!

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 18:50'!
anyKeyMulti
	^($_ asParser, $: asParser) ==> [:node | self identifier, $: asParser].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 19:09'!
anyKeyUnary
	^($_ asParser, $: asParser not) ==> [:node | self identifier].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:03'!
binary
	^ ((PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') ,
	  (PPPredicateObjectParser anyOf: '!!%&*+,/<=>?@\|~') star) flatten token ==> [:node | node value asParser]! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 14:12'!
identifier
	^ #letter asParser, #word asParser star! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:02'!
keyword
	^ (identifier , $: asParser) token ==> [:node | node value asParser].! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 18:24'!
multiword
	^ (keyword | anyKeyMulti) plus! !

!PhSelectorParser methodsFor: 'parser' stamp: 'DanielGaldames 3/18/2011 19:05'!
start
	^ (unary / anyKeyUnary  / binary / multiword) end ==> [:node |
		(node isCollection) 
			ifTrue: [
				(node size > 1) 
					ifTrue:  [| p |
						p := node reduce: [:a :b | a,b].
						p end] 
					ifFalse: [(node at: 1) end]  ]
			ifFalse: [node end] ]! !

!PhSelectorParser methodsFor: 'tokens' stamp: 'DanielGaldames 3/18/2011 17:03'!
unary
	^ (identifier, $: asParser not) token ==> [:node | node value asParser]! !

Object subclass: #PhAdvice
	instanceVariableNames: 'type pointcut advice owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAdvice commentStamp: 'DanielGaldames 4/13/2011 23:36' prior: 0!
PhAdvice represents a pointcut, advice pair.
Use pointcut:  to declare the joinpoint to capture, using an instance of PhPointcut.
Use type: to declare the type of the advice,
	#before
	#after
	#around.
Use advice: to add the method to execute on the captued joinpoints.
advice: accept a block or a selector, with 0 arguments (if no context is captured on the pointcut), or 1 arguments for the context captured on the joinpoint.
you can also use selector:of: to send a message on an object for advice.
Example: 
	PhAdvice new
		pointcut: aPointcut;
		type: #before;
		advice: [:context | Transcript show: context receiver asString].
		
	PhAdvice new
		pointcut: aPointcut;
		type: #around;
		selector: #theAdviceOnFoo: of: foo.  !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/20/2011 14:10'!
advice: aSymbolOrBlockOrSymbolBlockArray
	advice := aSymbolOrBlockOrSymbolBlockArray.! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 17:57'!
on: aObject selector: aSymbol
	self advice: (Array with: aObject with: aSymbol)  ! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/25/2011 22:15'!
owner
	^ owner ! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/25/2011 22:14'!
owner: anAspect
	owner := anAspect! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:50'!
pointcut
	^ pointcut! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:50'!
pointcut: aPhPointcut
	pointcut := aPhPointcut! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/27/2011 21:06'!
run
	(advice isSymbol) ifTrue: [ ^(self perform: advice) ].
	(advice isBlock) ifTrue: [^(advice value) ].
	^((advice at: 1) perform: (advice at: 2))
	    ! !

!PhAdvice methodsFor: 'private' stamp: 'DanielGaldames 3/20/2011 14:18'!
runWithin: aContext
	(advice isSymbol) ifTrue: [ ^(self perform: advice with: aContext) ].
	(advice isBlock) ifTrue: [^(advice value: aContext) ].
	^((advice at: 1) perform: (advice at: 2) with: aContext)
	    ! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 4/6/2011 21:50'!
selector: aSymbol of: aObject
	self advice: (Array with: aObject with: aSymbol)  ! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 17:56'!
selector: aSymbol on: aObject
	self advice: (Array with: aObject with: aSymbol)  ! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:51'!
type
	^ type ifNil: [type := #before]! !

!PhAdvice methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 16:51'!
type: aSymbol
	type := aSymbol! !

Object subclass: #PhAspect
	instanceVariableNames: 'adviceCollection precedence classModifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAspect commentStamp: 'DanielGaldames 4/13/2011 23:50' prior: 0!
PhAspect represent an Aspect, it has a collection of PhAdvices, an PhClassModifiers.
Use add: to add advices.
Use addClassModifier: to add a classModifier.
Use precedence: to specify the desired precedence on the installed aspects.
Use install to install it, and uninstall to uninstall the aspect.
Example:
	PhAspect new
		add: (PhAdvice new ...);
		addClassMofifier: (PhClassModifier new on: ...);
		precedence: 'PhAspectBigger+ PhAspectFoo'.!

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 4/17/2011 19:58'!
add: anAdvice
	anAdvice owner: self.
	adviceCollection add: anAdvice! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 4/13/2011 22:39'!
addClassModifier: aClassModifier
	classModifiers add: aClassModifier.! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/20/2011 16:50'!
adviceCollection
	^ adviceCollection! !

!PhAspect methodsFor: 'initialization' stamp: 'DanielGaldames 4/18/2011 15:53'!
initialize
	adviceCollection := OrderedCollection new.
	classModifiers := Set new.! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/13/2011 22:40'!
install
	classModifiers do: [:each | each install].
	PhAspectWeaver install: self! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/25/2011 20:13'!
precedence
	^ precedence ifNil: [precedence := #()]  ! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/25/2011 20:13'!
precedence: aPrecedenceArray
	precedence := aPrecedenceArray! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 3/8/2011 19:24'!
remove: anAdvice
	adviceCollection remove: anAdvice! !

!PhAspect methodsFor: 'accessing' stamp: 'DanielGaldames 4/13/2011 22:39'!
removeClassModifier: aClassModifier
	classModifiers remove: aClassModifier! !

!PhAspect methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/13/2011 22:40'!
uninstall
	PhAspectWeaver unInstall: self.
	classModifiers do: [:each | each uninstall]! !

Object subclass: #PhAspectWeaver
	instanceVariableNames: ''
	classVariableNames: 'InstalledAspects WrapperList'
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhAspectWeaver commentStamp: 'DanielGaldames 4/14/2011 01:11' prior: 0!
This class is responsable to weave the aspects into the system.!

!PhAspectWeaver classSide methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/11/2011 01:29'!
activateSystemNotification
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Modified
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Removed
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #classRename:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Added
		using: #systemEvent:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Modified
		using: #methodModification:.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method
		change: #Removed
		using: #methodRemoved:! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'DanielGaldames 3/20/2011 16:37'!
addAspect: aPhAspect
	self installedAspects add: aPhAspect. ! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'DanielGaldames 4/11/2011 00:40'!
classRename: anEvent
	anEvent item methodDict do: [:each |
		(each isKindOf: PhAspectMethodWrapper)
			ifTrue: [
				each reference setClass: (anEvent item) methodSymbol: (each reference methodSymbol)]].
	self updateAspects.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/10/2011 21:23'!
cleanWrappers
	WrapperList notEmpty 
		ifTrue: [
			WrapperList do: [:each | each uninstall ].
			WrapperList removeAll].! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:52'!
combineOrderOf: aSortedAdvicesCollection and: anotherSortedAdviceCollection
	| combinedCollection rest |
	combinedCollection := OrderedCollection new.
	rest := OrderedCollection new.
	combinedCollection addAll: aSortedAdvicesCollection.
	anotherSortedAdviceCollection reverseDo: [:each |
		(combinedCollection includes: each) 
			ifTrue: [	rest do: [:adv | combinedCollection add: adv after: each]. rest removeAll]
			ifFalse: [rest addFirst: each]].
	combinedCollection addAllFirst: rest.
	^combinedCollection  ! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/18/2011 16:01'!
compileAndInstallWrappers
	| pointcutDict aspectRulesDict |
	pointcutDict := Dictionary new.
	self installedAspects do: [:aspect | 
		aspect adviceCollection do: [:advice |
			advice pointcut getPointcuts do: [:pointcut |
				pointcutDict at: pointcut
					ifPresent: [:ascol |
						(ascol includes: advice) ifFalse: [ascol add: advice]]
					ifAbsent: [| ascol |
						ascol := OrderedCollection new.
						ascol add: advice.
						pointcutDict at: pointcut put: ascol] ]]].
	WrapperList := self getWrapperListWith: pointcutDict.

	WrapperList do: [:each | each install]! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/19/2011 13:04'!
getWrapperListWith: aPointcutDictionary
	| dict |
	dict := Dictionary new.
	aPointcutDictionary keysAndValuesDo: [:key :value |
		| sorted | 
		sorted := self setPrecedenceOn: (self setInheritancePrecedenceOn: value).
		dict at: key put: (PhAspectMethodWrapper on: (key at: 1) selector: (key at: 2) with: sorted)].
	^dict  ! !

!PhAspectWeaver classSide methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/11/2011 01:29'!
initialize
	super initialize.
	self activateSystemNotification.
	WrapperList := Dictionary new.! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'DanielGaldames 3/21/2011 02:33'!
install: anAspect
	self cleanWrappers.
	self addAspect: anAspect.
	self compileAndInstallWrappers.  ! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'DanielGaldames 3/21/2011 02:45'!
installedAspects
	^ InstalledAspects ifNil: [InstalledAspects := Set new.]! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'DanielGaldames 4/11/2011 00:18'!
methodModification: anEvent
	(anEvent oldItem isKindOf: PhAspectMethodWrapper)
		ifTrue: [ 
			anEvent oldItem oldMethod: anEvent item.
			anEvent oldItem needCleanUp: false.
			anEvent oldItem install ]! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'DanielGaldames 4/11/2011 01:21'!
methodRemoved: anEvent
	(anEvent item isKindOf: PhAspectMethodWrapper)
		ifTrue: [WrapperList removeKey: (Array with: (anEvent itemClass) with: (anEvent item selector) )].
	self updateAspects.! !

!PhAspectWeaver classSide methodsFor: 'accessors' stamp: 'DanielGaldames 3/21/2011 01:44'!
removeAspect: aPhAspect
	self installedAspects remove: aPhAspect ifAbsent: nil.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 4/19/2011 15:53'!
setInheritancePrecedenceOn: anAdviceCollection
	| aspectList adviceList workingSet tmp |
	aspectList := Set new.
	aspectList add: PhAspect.
	aspectList addAll: PhAspect allSubclasses.
	adviceList := OrderedCollection new.
	adviceList addAll: (anAdviceCollection select: [:adv | adv owner class theNonMetaClass = PhAspect]).
	workingSet := OrderedCollection with: PhAspect.
	tmp := OrderedCollection new.
	[aspectList notEmpty] whileTrue: [
		tmp removeAll.
		workingSet do: [:father |
			tmp addAll: (aspectList select: [:asp | asp superclass = father]).
			aspectList remove: father].
		tmp do: [:asp |
				adviceList addAll: (anAdviceCollection select: [:adv | adv owner class theNonMetaClass = asp])].
		workingSet removeAll.
		workingSet addAll: tmp].
	^ adviceList.! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:09'!
setPrecedenceOn: anAdviceSet
	"ordenar basado en precedencia"
	| pointcutRulesSet pointcutOverrideRuleSet aspectRulesSet sortedAspects sortedAdvices |
	aspectRulesSet := Set new.
	pointcutRulesSet := Set new.
	pointcutOverrideRuleSet := Set new.
	anAdviceSet do: [:adv |
		(adv owner precedence notEmpty) ifTrue: [aspectRulesSet add: adv owner precedence].
		(adv pointcut precedence notEmpty) ifTrue: [
			(adv pointcut override) 
				ifFalse: [pointcutRulesSet add: adv pointcut precedence]
				ifTrue: [pointcutOverrideRuleSet add: adv pointcut precedence]]].
	((aspectRulesSet isEmpty) & (pointcutRulesSet isEmpty) & (pointcutOverrideRuleSet isEmpty)) ifTrue: [^anAdviceSet].
	(pointcutOverrideRuleSet isEmpty) 
		ifFalse: [
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: pointcutOverrideRuleSet.  
			sortedAdvices := self sort: anAdviceSet from: sortedAspects.  
			(anAdviceSet difference: sortedAdvices) do: [:e | sortedAdvices add: e].
			^sortedAdvices. ]
		ifTrue: [
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: pointcutRulesSet.
			sortedAdvices := self sort: anAdviceSet from: sortedAspects.
			sortedAspects := PhPrecedenceRulesProcessor new getSortedAspectsWith: aspectRulesSet.
			sortedAdvices := self combineOrderOf: sortedAdvices and: (self sort: anAdviceSet from: sortedAspects).
			^sortedAdvices]! !

!PhAspectWeaver classSide methodsFor: 'private' stamp: 'DanielGaldames 3/29/2011 12:44'!
sort: anAdvicesCollection from: aSortedAspectCollection
	| sortedAdvices |
	sortedAdvices := OrderedCollection new.
	aSortedAspectCollection do: [:each |
		| col |
		col := anAdvicesCollection select: [:adv | adv owner class = each].
		col do: [:adv | sortedAdvices add: adv]].
	^sortedAdvices.! !

!PhAspectWeaver classSide methodsFor: 'notification' stamp: 'DanielGaldames 4/11/2011 00:47'!
systemEvent: anEvent
	self updateAspects.! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'DanielGaldames 3/20/2011 22:35'!
unInstall: anAspect
	self cleanWrappers.
	self removeAspect: anAspect.
	self compileAndInstallWrappers.    ! !

!PhAspectWeaver classSide methodsFor: 'install/uninstall' stamp: 'DanielGaldames 3/21/2011 12:31'!
uninstallAll
	self installedAspects removeAll.
	self cleanWrappers.  ! !

!PhAspectWeaver classSide methodsFor: 'update' stamp: 'DanielGaldames 4/10/2011 21:24'!
updateAspects
	self cleanWrappers.
	self compileAndInstallWrappers.! !

Object subclass: #PhClassModifier
	instanceVariableNames: 'modifiedClass newInstanceMethodDict newClassMethodDict newInstanceVar newClassVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhClassModifier commentStamp: 'DanielGaldames 4/14/2011 01:22' prior: 0!
This class is use to declare the modification to do on a class, at the moment of install an aspect.
You can add instance variables, class variables, instance methods and class side methods.
This modifications are rolled back on uninstall.!

!PhClassModifier methodsFor: 'method-manipulation' stamp: 'DanielGaldames 4/13/2011 20:33'!
addNewClassMethod: aMethodString
	| aSelector |
	aSelector := (RBParser parseMethod: aMethodString) selector.
	(modifiedClass theMetaClass localSelectors includes: aSelector)
		ifFalse: 	[newClassMethodDict add: (aSelector -> aMethodString)]
		ifTrue: [self error: 'method already defined']! !

!PhClassModifier methodsFor: 'variable-manipulation' stamp: 'DanielGaldames 4/13/2011 21:18'!
addNewClassVar: aClassVarName
	| varName |
	varName := aClassVarName capitalized.
	(modifiedClass hasClassVarNamed: varName) 
		ifFalse:	[newClassVar add: varName]
		ifTrue: [self error: 'variable already defined']! !

!PhClassModifier methodsFor: 'method-manipulation' stamp: 'DanielGaldames 4/13/2011 20:32'!
addNewInstanceMethod: aMethodString
	| aSelector |
	aSelector := (RBParser parseMethod: aMethodString) selector.
	(modifiedClass localSelectors includes: aSelector)
		ifFalse: 	[newInstanceMethodDict add: (aSelector -> aMethodString)]
		ifTrue: [self error: 'method already defined']! !

!PhClassModifier methodsFor: 'variable-manipulation' stamp: 'DanielGaldames 4/13/2011 20:31'!
addNewInstanceVar: anInstanceVarName
	(modifiedClass hasInstVarNamed: anInstanceVarName) 
		ifFalse:	[newInstanceVar add: anInstanceVarName]
		ifTrue: [self error: 'variable already defined']! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 20:48'!
checkExistence
	newInstanceVar do: [:varName |
		(modifiedClass theNonMetaClass hasInstVarNamed: varName) ifTrue: [self error: 'instance variable already defined!!']].
	newClassVar do: [:varName |
		(modifiedClass theNonMetaClass hasClassVarNamed: varName) ifTrue: [self error: 'class variable already defined!!']].
	newInstanceMethodDict keysDo: [:selector |
		(modifiedClass theNonMetaClass localSelectors includes: selector) ifTrue: [self error: 'instance method already defined!!']].
	newClassMethodDict keysDo: [:selector |
		(modifiedClass theMetaClass localSelectors includes: selector) ifTrue: [self error: 'class method already defined!!']]  
	! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 01:29'!
compileClassMethod: aMethodString
	modifiedClass theMetaClass compile: aMethodString classified: '*phantom-generated-method'  ! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 01:29'!
compileMethod: aMethodString
	modifiedClass compile: aMethodString classified: '*phantom-generated-method'  ! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/13/2011 20:19'!
initialize
	newInstanceMethodDict := Dictionary new.
	newClassMethodDict := Dictionary new.
	newInstanceVar := Set new.
	newClassVar := Set new.! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/13/2011 20:52'!
install
	self checkExistence.
	newInstanceVar do: [:varName | modifiedClass theNonMetaClass addInstVarNamed: varName].
	newClassVar do: [:varName | modifiedClass theNonMetaClass addClassVarNamed: varName].
	newClassMethodDict do: [:methodString | self compileClassMethod: methodString ].
	newInstanceMethodDict do: [:methodString | self compileMethod: methodString ]! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 16:17'!
modifiedClass
	^ modifiedClass! !

!PhClassModifier methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/13/2011 16:33'!
on: aClass
	modifiedClass := aClass.! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 20:23'!
removeClassVar: aClassVarName
	newClassVar remove: aClassVarName! !

!PhClassModifier methodsFor: 'private' stamp: 'DanielGaldames 4/13/2011 20:24'!
removeInstanceVar: anIntanceVarName
	newInstanceVar remove: anIntanceVarName! !

!PhClassModifier methodsFor: 'install-uninstall' stamp: 'DanielGaldames 4/13/2011 21:15'!
uninstall
	newClassMethodDict keysDo: [:selector | modifiedClass theMetaClass removeSelector: selector].
	newInstanceMethodDict keysDo: [:selector | modifiedClass theNonMetaClass removeSelector: selector].
	modifiedClass organization removeEmptyCategories.
	modifiedClass theMetaClass organization removeEmptyCategories.
	newClassVar do: [:classVarName | modifiedClass theNonMetaClass removeClassVarNamed: classVarName].
	newInstanceVar do: [:instanceVarName | modifiedClass theNonMetaClass removeInstVarNamed: instanceVarName]    ! !

Object subclass: #PhContext
	instanceVariableNames: 'receiver arguments selector method sender dynamicContext adviceDictionary currentAdviceGroup wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhContext commentStamp: 'DanielGaldames 4/14/2011 01:28' prior: 0!
This class is used to pass the context of execution to the advices on aspects!

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 4/18/2011 12:57'!
adviceDictionary
	^adviceDictionary ! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:57'!
afterAdvice
	^ adviceDictionary at: #after! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:58'!
afterAdvice: adviceCollection
	adviceDictionary at: #after put: adviceCollection asArray.
	wrapper afterAdvice: (adviceDictionary at: #after)! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
arguments
	^ arguments! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
arguments: anObject
	arguments := anObject! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:57'!
aroundAdvice
	^ adviceDictionary at: #around! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:58'!
aroundAdvice: adviceCollection
	adviceDictionary at: #around put: adviceCollection asArray.
	wrapper aroundAdvice: (adviceDictionary at: #around)  ! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:56'!
beforeAdvice
	^ adviceDictionary at: #before! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:58'!
beforeAdvice: adviceCollection
	adviceDictionary at: #before put: adviceCollection asArray.
	wrapper beforeAdvice: (adviceDictionary at: #before)  ! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:56'!
currentAdvice
	^ adviceDictionary at: currentAdviceGroup! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/18/2011 13:57'!
currentAdvice: anAdviceCollection continueAt: anIndex
	adviceDictionary at: currentAdviceGroup put: anAdviceCollection asArray.
	wrapper perform: ((currentAdviceGroup, 'Advice:') asSymbol) with: (adviceDictionary at: currentAdviceGroup).
	wrapper current: (anIndex -1)! !

!PhContext methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/17/2011 17:17'!
currentAdviceGroup: aSymbol
	currentAdviceGroup := aSymbol! !

!PhContext methodsFor: 'advices' stamp: 'DanielGaldames 4/17/2011 18:52'!
currentAdviceIndex
	^wrapper current.! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:40'!
dynamicContext
	^dynamicContext! !

!PhContext methodsFor: 'initialize-release' stamp: 'DanielGaldames 4/18/2011 12:57'!
initialize
	super initialize.
	dynamicContext := Dictionary new.
	adviceDictionary := Dictionary	newFrom: {
		#before -> nil.
		#after -> nil.
		#around -> nil}! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
method
	^ method! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
method: anObject
	method := anObject! !

!PhContext methodsFor: 'proceed' stamp: 'DanielGaldames 3/21/2011 13:33'!
proceed
	^ method valueWithReceiver: receiver arguments: arguments.  ! !

!PhContext methodsFor: 'proceed' stamp: 'DanielGaldames 3/22/2011 00:32'!
proceed: args
	^ method valueWithReceiver: receiver arguments: args.  ! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
receiver
	^ receiver! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
receiver: anObject
	receiver := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
selector
	^ selector! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/21/2011 02:02'!
selector: anObject
	selector := anObject! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 14:03'!
sender
	^ sender! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 14:03'!
sender: aSender
	sender := aSender! !

!PhContext methodsFor: 'accessing' stamp: 'DanielGaldames 4/17/2011 18:21'!
wrapper: aWrapper
	wrapper := aWrapper! !

Object subclass: #PhPointcut
	instanceVariableNames: 'selectors receivers pointcut composition selectIfMatch context precedence overrideRules dynamicContextBlock localSelectors'
	classVariableNames: 'Modifiers'
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPointcut commentStamp: 'DanielGaldames 4/14/2011 01:58' prior: 0!
This class is used to define a pointcut.
The joinpoint model is based on messsage reception.
You have to define the receivers of the message, and the message (selectors).
Example:
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: 'foo:'.
	
	To select the metaclass:
	Example:
	PhPointcut new
		receivers: 'PhMockClass class';
		selectors: 'foo:'.
		
You can use some wildcards (like in AspectJ).
Example:
	Any receiver that have MockClass on his name.
	PhPointcut new
		receivers: '*MockClass*';
		selectors: 'foo:'.
		
	PhMockClass and all its subclasses:
	PhPointcut new
		receivers: 'PhMockClass+';
		selectors: 'foo:'.
		
On the selectors you can use '_' for any non argument selector, or '_:' any selector that receive an argument:
Example:
	Any selector of PhMockClass that receive a two argument message.
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: '_:_:'.
		
You can pass groups of receivers and selectors as Arrays
Example:
	PhPointcut new
		receivers: #('Foo' 'Bar' 'SomeClass');
		selectors: #('foo:' 'bar').

You can also pass a PetitParser parser as receivers or selectors.
The classes definition that mathces the parser will be selected as receivers.
On the selectors, the selectors that matches the parser will be selected.

You can define the context to pass to the advices:
	PhPointcut new
		receivers: 'PhMockClass';
		selectors: 'foo:';
		context: #(#receiver #sender #selector #arguments #proceed).
		
You can override the precedence on defined on an aspect with overridePrecedence: #(...).
You can define a different precedence with precedence: #(...), this precedence has higher priority than the precedence defined on the aspects.
You can combine pointcuts using (and) pand: , (or) por: , and not.
Example: 
	(aPointcut1 pand: aPoincut2) por: aPointcut3.!

!PhPointcut classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/14/2011 01:39'!
receviersParser
	^ PhReceiverParser new.! !

!PhPointcut classSide methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 3/18/2011 22:29'!
selectorsParser
	^ PhSelectorParser new.! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
composition
	^ composition! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
composition: anObject
	composition := anObject! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 12:46'!
context
	^ context ifNil: [context := #()]  ! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 12:44'!
context: anArray 
	context := anArray! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 4/3/2011 00:56'!
createPointcutListWith: receviersParser and: selectorsParser
	| aSet selSelector |
	aSet := Set new.
	localSelectors ifTrue: [selSelector := #localSelectors] ifFalse: [selSelector := #allSelectors].
	SmalltalkImage current allClasses
		do: [ :each | 
			selectIfMatch
				ifTrue: [ 
					(receviersParser matches: each definition)
						ifTrue: [ 
							(each perform: selSelector)  
								do: [ :sel | 
									(selectorsParser matches: sel asString)
										ifTrue: [ aSet add: (Array with: each with: sel) ] ] ].
					(receviersParser matches: each class definition)
						ifTrue: [ 
							(each class perform: selSelector)  
								do: [ :sel | 
									(selectorsParser matches: sel asString)
										ifTrue: [ aSet add: (Array with: each class with: sel) ] ] ] ]
				ifFalse: [ 
					(receviersParser matches: each definition) not
						ifTrue: [ (each perform: selSelector)  do: [ :sel | aSet add: (Array with: each with: sel) ] ]
						ifFalse: [ 
							(each perform: selSelector)  
								do: [ :sel | 
									(selectorsParser matches: sel asString) not
										ifTrue: [ aSet add: (Array with: each with: sel) ] ] ].
					(receviersParser matches: each class definition) not
						ifTrue: [ (each class perform: selSelector)   do: [ :sel | aSet add: (Array with: each class with: sel) ] ]
						ifFalse: [ 
							(each class perform: selSelector)  
								do: [ :sel | 
									(selectorsParser matches: sel asString) not
										ifTrue: [ aSet add: (Array with: each class with: sel) ] ] ] ] ].
	^ aSet! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:46'!
dynamicContext
	^dynamicContextBlock! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/30/2011 19:46'!
dynamicContext: aContextCreatorBlock
	dynamicContextBlock := aContextCreatorBlock! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 00:45'!
getPointcuts
	| receiversList selectorList pointcuts |
	receiversList := self createPointcutListWith: (self parseReceivers: self receivers) and: (self parseSelectors: self selectors).
	(self pointcut notNil) ifTrue: [
		receiversList := receiversList perform: (self composition) with: (self pointcut getPointcuts)  ].
	^receiversList
	! !

!PhPointcut methodsFor: 'initialize-release' stamp: 'DanielGaldames 3/30/2011 19:51'!
initialize
	pointcut := nil.
	composition := nil.
	selectIfMatch := true.
	overrideRules := false.
	dynamicContextBlock := nil.! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/8/2011 17:06'!
isActiveOnContext: aContext
	^true! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 00:44'!
localSelectors: aParserOrString
	localSelectors := true.
	selectors := aParserOrString! !

!PhPointcut methodsFor: 'composing' stamp: 'DanielGaldames 3/31/2011 17:36'!
not
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: self pointcut;
		composition: self composition;
		selectIfMatch: self selectIfMatch not;
		context: self context;
		precedence: self precedence;
		override: self override;    
		yourself.! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 23:00'!
override
	^overrideRules! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/31/2011 17:35'!
override: aBoolean
	overrideRules := aBoolean.! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 23:03'!
overridePrecedence: anArray 
	overrideRules := true.
	precedence := anArray! !

!PhPointcut methodsFor: 'composing' stamp: 'DanielGaldames 3/31/2011 17:37'!
pand: aPonitcut
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: aPonitcut;
		composition: #intersection:;
		selectIfMatch: self selectIfMatch;
		context: self context;
		precedence: self precedence;
		override: self override;    
		yourself.    ! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 4/3/2011 18:44'!
parseReceivers:  receiversDefinition
	^ (receiversDefinition isPetitParser)
		ifTrue: [receivers] 
		ifFalse: [
			(receiversDefinition isString) 
			ifTrue: [PhPointcut receviersParser parse: receiversDefinition]
			ifFalse: [ 
				(receiversDefinition size = 1) 
					ifTrue: [PhPointcut receviersParser parse: (receiversDefinition at: 1)]
					ifFalse: [
						receiversDefinition reduce: [:a :b | 
							| parserA parserB |
							(a isPetitParser) ifTrue: [parserA := a] ifFalse: [parserA := PhPointcut receviersParser parse: a].
							(b isPetitParser) ifTrue: [parserB := b] ifFalse: [parserB := PhPointcut receviersParser parse: b]. 
							parserA / parserB]]   ]].   ! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/22/2011 00:12'!
parseSelectors:  selectorsDefinition
	^ (selectorsDefinition isPetitParser) 
		ifTrue: [selectorsDefinition] 
		ifFalse: [
			(selectorsDefinition isString)
				ifTrue: [PhPointcut selectorsParser parse: selectorsDefinition] 
				ifFalse: [
					(selectorsDefinition size = 1)
						ifTrue: [PhPointcut selectorsParser parse: (selectorsDefinition at: 1)] 
						ifFalse: [
							selectorsDefinition reduce: [:a :b | (PhPointcut selectorsParser parse: a) / (PhPointcut selectorsParser parse: b)]]  ]].   
	"| receiversList sel |
	receiversList := self expandReceivers.
	sel := (selectorsString subStrings: ' ') collect: [:e | e asSymbol].
	^ receiversList collect: [:r | sel]"! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
pointcut
	^ pointcut! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/13/2011 16:15'!
pointcut: anObject
	pointcut := anObject! !

!PhPointcut methodsFor: 'composing' stamp: 'DanielGaldames 3/31/2011 17:36'!
por: aPointcut
	^(PhPointcut new)
		selectors: self selectors;
		receivers: self receivers;
		pointcut: aPointcut;
		composition: #union:;
		selectIfMatch: self selectIfMatch;
		context: self context;
		precedence: self precedence;
		override: self override;
		yourself.  ! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/28/2011 22:45'!
precedence
	^precedence ifNil: [precedence := #()]! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 00:38'!
precedence: anArray
	overrideRules := false.
	precedence := anArray! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/18/2011 19:38'!
receivers
	^receivers ifNil: [#any asParser star not]! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/12/2011 20:10'!
receivers: aParserOrString
	receivers := aParserOrString! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/18/2011 22:37'!
selectIfMatch
	^selectIfMatch! !

!PhPointcut methodsFor: 'private' stamp: 'DanielGaldames 3/18/2011 22:37'!
selectIfMatch: aBoolean
	selectIfMatch := aBoolean! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 3/18/2011 19:38'!
selectors
	^selectors ifNil: [#any asParser star not]! !

!PhPointcut methodsFor: 'accessing' stamp: 'DanielGaldames 4/3/2011 00:44'!
selectors: aParserOrString
	localSelectors := false.
	selectors := aParserOrString! !

Object subclass: #PhPrecedenceRulesProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phantom-Core'!

!PhPrecedenceRulesProcessor commentStamp: 'DanielGaldames 4/14/2011 01:55' prior: 0!
This class is reponsable to process the precedence rules and order the advices action on a pointcut.!

!PhPrecedenceRulesProcessor methodsFor: 'graph generation' stamp: 'DanielGaldames 3/25/2011 13:56'!
getGraphFrom: aNodeCollection
	| graph |
	graph := AspectGraph new.
	aNodeCollection reduce: [:parents :children |
		graph addAll: parents.
		graph addAll: children.
		parents do: [:node |
			children do: [:child |
				(graph nodeSet like: node) addNode: (graph nodeSet like: child)]].
		children.].
	^graph.! !

!PhPrecedenceRulesProcessor methodsFor: 'aspect sorting' stamp: 'DanielGaldames 3/29/2011 22:28'!
getSortedAspectsWith: aRulesSet
	| graphs graph |
	(aRulesSet isEmpty) ifTrue: [^#()].
	graphs := OrderedCollection new.
	aRulesSet collect: [:rulesArray |
		| nodeCollection |
		nodeCollection := OrderedCollection new.
		rulesArray do: [:rule | nodeCollection add: (PhPrecedenceRulesParser new parse: rule)].
		"lipieza por relga *"
		rulesArray withIndexDo: [:elem :index |
			(elem = '*') ifTrue: [
				nodeCollection withIndexDo: [:col :idx |
					((rulesArray at: idx) = '*') not ifTrue: [
						nodeCollection at: index put: ((nodeCollection at: index) difference: col)]]]].
		graphs add: nodeCollection].
	graph := OrderedCollection new.
	graphs do: [:each |
		| g |
		g := self getGraphFrom: each.
		graph add: g].
	graph := graph reduce: [:a :b | a merge: b].
	(graph existsCycle) ifTrue: [self error: 'Conflict detected in rules set'].
	graph setPrecedence.
	^ (graph nodeSet asArray sort: [:a :b | a precedence < b precedence]) collect: [:each | each aspect].! !
PhAspectWeaver initialize!
